%define section free

# If you do not want cos-multipart support, give rpmbuild option '--without nonfree'
%define with_nonfree %{!?_without_nonfree:1}%{?_without_nonfree:0}
%define without_nonfree %{?_without_nonfree:1}%{!?_without_nonfree:0}

Summary:        Web application framework for J2EE
Name:           webwork
Version:        2.1.7
Release:        1jpp
Epoch:          0
License:        Apache Software License modified
URL:            http://www.opensymphony.com/webwork/
Group:          Development/Libraries/Java
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        webwork-2.1.7.zip
Source1:        webwork-LICENSE.txt
Patch0:         webwork-2.1.7-PellMultiPartRequest.patch
Patch1:         webwork-Multipart.patch
Patch2:         webwork-build_xml.patch
Patch3:         webwork-Script.patch
Patch4:         webwork-ChartResultTest.patch
BuildRequires:  java-devel >= 0:1.4
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-junit >= 0:1.6
BuildRequires:  ant-nodeps >= 0:1.6
BuildRequires:  junit >= 0:3.8.1
BuildRequires:	jsch
BuildRequires:	mockobjects
BuildRequires:	mockobjects-alt-jdk1.4
BuildRequires:	mockobjects-jdk1.4
BuildRequires:	mockobjects-jdk1.4-j2ee1.3
#
%if %{with_nonfree}
BuildRequires:  cos-multipart >= 0:0.05Nov2002
%endif
BuildRequires:	bsf
BuildRequires:	bsh
BuildRequires:	freemarker
BuildRequires:	itext
BuildRequires:	jakarta-commons-beanutils
BuildRequires:	jakarta-commons-collections
BuildRequires:	jakarta-commons-digester
BuildRequires:	jakarta-commons-fileupload
BuildRequires:	jakarta-commons-lang
BuildRequires:	jakarta-commons-logging
BuildRequires:	jakarta-poi
BuildRequires:	jakarta-taglibs-standard
BuildRequires:  jasperreports >= 0:1.0.0
BuildRequires:	javamail
BuildRequires:	jcommon
BuildRequires:  jfreechart >= 0:0.9.21
BuildRequires:	log4j
BuildRequires:	ognl
BuildRequires:	oscore
BuildRequires:	pell-multipart
BuildRequires:	servletapi4
BuildRequires:	velocity
BuildRequires:	xml-commons-apis
BuildRequires:	xwork
Requires:	bsf
Requires:	bsh
Requires:	freemarker
Requires:	itext
Requires:	jakarta-commons-beanutils
Requires:	jakarta-commons-collections
Requires:	jakarta-commons-digester
Requires:	jakarta-commons-fileupload
Requires:	jakarta-commons-lang
Requires:	jakarta-commons-logging
Requires:	jakarta-poi
Requires:	jakarta-taglibs-standard
Requires:	jasperreports >= 0:1.0.0
Requires:	javamail
Requires:	jcommon
Requires:	jfreechart >= 0:0.9.21
Requires:	log4j
Requires:	ognl
Requires:	oscore
Requires:	pell-multipart
Requires:	servletapi4
Requires:	velocity
Requires:	xml-commons-apis
Requires:	xwork

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
WebWork is a Java web-application development framework. 
It is built specifically with developer productivity and 
code simplicity in mind. WebWork is built on top of XWork, 
which provides a generic command pattern framework as well 
as an Inversion of Control container. In addition to these 
features, WebWork provides robust support for building 
reusable UI templates, such as form controls, UI themes, 
internationalization, dynamic form parameter mapping to 
JavaBeans, robust client and server side validation, 
and much more. 

%package multipart
Summary:        Multipart support for %{name}
Group:          Development/Libraries/Java
Requires:  pell-multipart
%if %{with_nonfree}
Requires:  cos-multipart
%endif

%description multipart
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -c -n %{name}
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done
# Remove example with db4o, this lib is non-free, commercial only
rm -rf src/main/webwork/examples/userreg
# Remove cos-multipart implementation, pell-multipart will do it
%if %{without_nonfree}
rm src/main/webwork/multipart/CosMultiPartRequest.java
%endif
cp src/example/log4j.properties src/test/log4j.properties
# this test fails
#rm src/test/com/opensymphony/webwork/interceptor/TokenSessionStoreInterceptorTest.java

%patch0 -b .sav
%if %{without_nonfree}
%patch1 -b .sav
%endif
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav

%build
export OPT_JAR_LIST="ant/ant-nodeps ant/ant-junit junit"
pushd lib/build
ln -sf $(build-classpath jsch) .
ln -sf $(build-classpath junit) .
ln -sf $(build-classpath mockobjects-j2ee1.3) .
ln -sf $(build-classpath mockobjects-alt) .
ln -sf $(build-classpath mockobjects) .
ln -sf $(build-classpath mockobjects-core) .
ln -sf $(build-classpath servletapi4) .
ln -sf $(build-classpath xml-commons-apis) xml-apis.jar
popd
pushd lib/core
ln -sf $(build-classpath commons-fileupload) .
ln -sf $(build-classpath commons-logging) .
%if %{with_nonfree}
ln -sf $(build-classpath cos-multipart) .
%endif
ln -sf $(build-classpath javamail/mailapi) mail.jar
ln -sf $(build-classpath ognl) .
ln -sf $(build-classpath oscore) .
ln -sf $(build-classpath pell-multipart) .
ln -sf $(build-classpath velocity) .
###BUILD/webwork/lib/core/velocity-dep.jar.no
ln -sf $(build-classpath xwork) .
popd
pushd lib/example
ln -sf $(build-classpath commons-beanutils) .
ln -sf $(build-classpath commons-collections) .
ln -sf $(build-classpath commons-lang) .
#BUILD/webwork/lib/example/displaytag.jar.no
#BUILD/webwork/lib/example/jstl.jar.no
ln -sf $(build-classpath taglibs-core) jstl.jar
ln -sf $(build-classpath taglibs-standard) standard.jar
#BUILD/webwork/lib/example/taglibs-benchmark.jar.no
popd
pushd lib/migration
ln -sf $(build-classpath bsf) .
ln -sf $(build-classpath poi) jakarta-poi.jar
popd
pushd lib/optional
ln -sf $(build-classpath bsh) .
ln -sf $(build-classpath commons-beanutils) .
ln -sf $(build-classpath commons-collections) .
ln -sf $(build-classpath commons-digester) .
ln -sf $(build-classpath freemarker) .
ln -sf $(build-classpath itext) .
ln -sf $(build-classpath poi) jakarta-poi.jar
ln -sf $(build-classpath jasperreports) .
ln -sf $(build-classpath jcommon) .
ln -sf $(build-classpath jfreechart) .
ln -sf $(build-classpath log4j) .
#BUILD/webwork/lib/optional/log4j-1.2.8.jar.no
popd
#pushd lib/resin
#BUILD/webwork/lib/resin/jmx.jar.no
#BUILD/webwork/lib/resin/jsdk23.jar.no
#BUILD/webwork/lib/resin/jta_101.jar.no
#BUILD/webwork/lib/resin/resin.jar.no
#popd


ant -Dbuild.sysclasspath=first dist

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}

cp -p build/%{name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
cp -p build/webflow-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/webflow-%{version}.jar
cp -p build/%{name}-config-browser.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-config-browser-%{version}.jar
cp -p build/%{name}-migration.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-migration-%{version}.jar
cp -p build/%{name}-multipart-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-multipart-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc
cp build/webwork.tld $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc
cp build/%{name}-example.war $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf build/dist/docs/api

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr build/dist/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp %{SOURCE1} $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/LICENSE.txt


%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_datadir}/%{name}-%{version}
%{_javadir}/*.jar
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_javadir}/webflow*.jar
%{_javadir}/%{name}-config-browser*.jar
%{_javadir}/%{name}-migration*.jar

%files multipart
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-multipart*.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

# -----------------------------------------------------------------------------

%changelog
* Wed Sep 21 2005 Ralph Apel <r.apel at r-apel.de> - 0:2.1.7-1jpp
- Update to 2.1.7
- Require jasperreports-1.0.0 
- Patch for jfreechart-0.9.21 and require it
- Patch for our pell-multipart
- One xwork/ognl related unit test failing

* Wed Feb 16 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.4-5jpp
- Patch for jasperreports-0.6.4 and require it

* Mon Aug 30 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.4-4jpp
- Build with ant-1.6.2
- Needs ant-junit and ant-nodeps

* Fri Jul 02 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.4-3jpp
- better solution for non-free exclusion (--without nonfree)
- relax versioned dependencies
- pell-multipart (and cos-multipart) are runtime deps only of webwork-multipart

* Mon Jun 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.4-2jpp
- put multipart classes into separate subpackage and jar
- optionally build without cos-multipart option (-D'without_nonfree 1')
- drop requires clover

* Tue Mar 02 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.4-1jpp
- First JPackage release
